Proxmox/misc/crowdsec.sh

86 lines
2.1 KiB
Bash
Raw Normal View History

2022-05-27 22:19:11 +02:00
#!/usr/bin/env bash
2023-02-07 18:15:22 +01:00
2024-01-01 18:13:05 +01:00
# Copyright (c) 2021-2024 tteck
2023-02-07 18:15:22 +01:00
# Author: tteck (tteckster)
# License: MIT
# https://github.com/tteck/Proxmox/raw/main/LICENSE
2022-10-30 02:04:45 +01:00
YW=$(echo "\033[33m")
BL=$(echo "\033[36m")
RD=$(echo "\033[01;31m")
BGN=$(echo "\033[4;92m")
GN=$(echo "\033[1;92m")
DGN=$(echo "\033[32m")
CL=$(echo "\033[m")
2022-05-27 22:19:11 +02:00
BFR="\\r\\033[K"
HOLD="-"
CM="${GN}${CL}"
APP="CrowdSec"
hostname="$(hostname)"
2022-05-27 22:19:11 +02:00
set -o errexit
set -o errtrace
set -o nounset
set -o pipefail
shopt -s expand_aliases
alias die='EXIT=$? LINE=$LINENO error_exit'
trap die ERR
function error_exit() {
2022-10-30 02:04:45 +01:00
trap - ERR
local reason="Unknown failure occured."
local msg="${1:-$reason}"
local flag="${RD}‼ ERROR ${CL}$EXIT@$LINE"
echo -e "$flag $msg" 1>&2
exit $EXIT
2022-05-27 22:19:11 +02:00
}
2022-11-26 00:52:37 +01:00
if command -v pveversion >/dev/null 2>&1; then echo -e "⚠️ Can't Install on Proxmox "; exit; fi
2022-05-27 22:19:11 +02:00
while true; do
read -p "This will Install ${APP} on $hostname. Proceed(y/n)?" yn
2022-05-27 22:19:11 +02:00
case $yn in
2022-10-30 02:04:45 +01:00
[Yy]*) break ;;
[Nn]*) exit ;;
*) echo "Please answer yes or no." ;;
2022-05-27 22:19:11 +02:00
esac
done
clear
function header_info {
2022-10-30 02:04:45 +01:00
echo -e "${BL}
2022-05-27 22:19:11 +02:00
_____ _ _____
/ ____| | |/ ____|
| | _ __ _____ ____| | (___ ___ ___
| | | __/ _ \ \ /\ / / _ |\___ \ / _ \/ __|
2022-05-27 22:19:11 +02:00
| |____| | | (_) \ V V / (_| |____) | __/ (__
\_____|_| \___/ \_/\_/ \__ _|_____/ \___|\___|
${CL}"
}
header_info
function msg_info() {
local msg="$1"
echo -ne " ${HOLD} ${YW}${msg}..."
}
function msg_ok() {
local msg="$1"
echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
}
msg_info "Setting up ${APP} Repository"
apt-get update &>/dev/null
2022-10-07 21:26:16 +02:00
apt-get install -y curl &>/dev/null
apt-get install -y gnupg &>/dev/null
2022-10-07 21:42:10 +02:00
curl -s https://packagecloud.io/install/repositories/crowdsec/crowdsec/script.deb.sh | bash &>/dev/null
2022-05-27 22:19:11 +02:00
msg_ok "Setup ${APP} Repository"
msg_info "Installing ${APP}"
2022-06-03 02:02:57 +02:00
apt-get update &>/dev/null
2022-05-27 22:19:11 +02:00
apt-get install -y crowdsec &>/dev/null
msg_ok "Installed ${APP} on $hostname"
2022-05-27 22:19:11 +02:00
msg_info "Installing ${APP} Common Bouncer"
apt-get install -y crowdsec-firewall-bouncer-iptables &>/dev/null
msg_ok "Installed ${APP} Common Bouncer"
msg_ok "Completed Successfully!\n"